#include "NamedCounter.h"

#include <iostream>

using std::cout;
using std::endl;

using std::string;

NamedCounterImpl::NamedCounterImpl(
   const string &name, 
   const CORBA::Long initialValue,
   PortableServer::POA_var poa)
   :  m_name(name),
      m_value(initialValue),
      m_poa(poa),
      m_objectID(m_poa->activate_object(this)),
      m_refCount(1)
{
   cout << "Named counter created: " << this << " \"" << m_name << "\" = " << m_value << endl;
}

NamedCounterImpl::~NamedCounterImpl()
{
   cout << "Named counter destroyed: " << this << " \"" << m_name << "\" = " << m_value << endl;
   m_poa->deactivate_object(m_objectID);
}

char *NamedCounterImpl::name()
{
   return CORBA::string_dup(m_name.c_str());
}

CORBA::Long NamedCounterImpl::value()
{
   return m_value;
}

void NamedCounterImpl::value(CORBA::Long value)
{
   m_value = value;
}

void NamedCounterImpl::AddRef()
{
   m_refCount++;

   cout << "AddRef(): " << this << " \"" << m_name << "\" refCount = " << m_refCount << endl;
}

void NamedCounterImpl::Release()
{
   cout << "Release(): " << this << " \"" << m_name << "\" refCount = " << (m_refCount - 1) << endl;

   if (--m_refCount == 0)
   {
      delete this;
   }
}
